package gus05.manager.gus.endorf.layer1;

import java.util.Date;
import javax.swing.JFrame;

import gus05.framework.core.Outside;
import gus05.manager.gus.endorf.layer1.organs.*;


public abstract class EndorfFrame extends JFrame {

    protected EndorfFrame(String[] args)
    {
        Date startDate = new Date();
        
        // initialize manager
        Endorf.setKeyFinder(buildKeyFinder());
        Endorf.setServiceWrapper(buildServiceWrapper());
        Endorf.setResourceProvider(buildResourceProvider());
        Endorf.setErrorHandler(buildErrorHandler());
        Outside.setManager(new EndorfManager());
        
        // launch application
        AppLauncher launcher = buildAppLauncher();
        launcher.launchApp(this,startDate,getAppName(),args);
    }
    
    protected abstract KeyFinder buildKeyFinder();
    protected abstract ServiceWrapper buildServiceWrapper();
    protected abstract ResourceProvider buildResourceProvider();
    protected abstract ErrorHandler buildErrorHandler();
    protected abstract AppLauncher buildAppLauncher();
    protected abstract String getAppName();
}
