package gus05.manager.gus.endorf.layer2.printstream;

import gus05.framework.features.Give;
import gus05.framework.features.Register;
import gus05.manager.gus.endorf.layer2.EndorfSystem;
import gus05.manager.gus.endorf.layer2.tools.Tools_printStream;

import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;


public class PrintStream1 extends PrintStream implements Give, Register {

    
    private PrintStream sysOut;
    private ArrayList list;
    private StringBuffer buffer;
    
    
    public PrintStream1()
    {
        super(Tools_printStream.nullOutput);
        sysOut = System.out;
        list = new ArrayList();
        buffer = new StringBuffer();
    }
    
    public void addPrintStream(PrintStream out)
    {list.add(out);}
    
    public void removePrintStream(PrintStream out)
    {list.remove(out);}
    
    public void initPrintStream(PrintStream out)
    {out.print(buffer);addPrintStream(out);}
    
    public PrintStream out(int index)
    {return (PrintStream) list.get(index);}
    
    public List list() {return list;}
    
    
    
    
    public void register(String key, Object obj) throws Exception
    {
        PrintStream out = (PrintStream)obj;
        if(key.equals("add")) {addPrintStream(out);return;}
        if(key.equals("remove")) {removePrintStream(out);return;}
        
        throw new Exception("Unknown key: "+key);
    }

    public void give(Object obj) throws Exception
    {initPrintStream((PrintStream)obj);}
    
    
    
    
    
    private boolean sysOutEnabled()
    {return EndorfSystem.systemOutEnabled();}
    
    
    
    
    
    
    public void print(String m)
    {
        buffer.append(m);
        for(int i=0;i<list.size();i++) out(i).print(m);
        if(sysOutEnabled())sysOut.print(m);
    }
    
    public void println()
    {
        buffer.append("\n");
        for(int i=0;i<list.size();i++) out(i).println();
        if(sysOutEnabled())sysOut.println();
    }
    
    public void println(String m)
    {
        buffer.append(m+"\n");
        for(int i=0;i<list.size();i++) out(i).println(m);
        if(sysOutEnabled())sysOut.println(m);
    }
    
    public void println(boolean val)
    {
        buffer.append(val+"\n");
        for(int i=0;i<list.size();i++) out(i).println(val);
        if(sysOutEnabled())sysOut.println(val);
    }
    
    public void println(char val)
    {
        buffer.append(val+"\n");
        for(int i=0;i<list.size();i++) out(i).println(val);
        if(sysOutEnabled())sysOut.println(val);
    }
    
    public void println(char[] val)
    {
        buffer.append(new String(val)+"\n");
        for(int i=0;i<list.size();i++) out(i).println(val);
        if(sysOutEnabled())sysOut.println(val);
    }
    
    public void println(double val)
    {
        buffer.append(val+"\n");
        for(int i=0;i<list.size();i++) out(i).println(val);
        if(sysOutEnabled())sysOut.println(val);
    }
    
    public void println(float val)
    {
        buffer.append(val+"\n");
        for(int i=0;i<list.size();i++) out(i).println(val);
        if(sysOutEnabled())sysOut.println(val);
    }
    
    public void println(int val)
    {
        buffer.append(val+"\n");
        for(int i=0;i<list.size();i++) out(i).println(val);
        if(sysOutEnabled())sysOut.println(val);
    }
    
    public void println(long val)
    {
        buffer.append(val+"\n");
        for(int i=0;i<list.size();i++) out(i).println(val);
        if(sysOutEnabled())sysOut.println(val);
    }
    
    public void println(Object val)
    {
        buffer.append(val+"\n");
        for(int i=0;i<list.size();i++) out(i).println(val);
        if(sysOutEnabled())sysOut.println(val);
    }
    
    
    public String toString()
    {return buffer.toString();}
    
    
    public void close()
    {for(int i=0;i<list.size();i++) out(i).close();}

}
