package gus05.manager.gus.endorf.layer3.loading;

import gus05.manager.gus.endorf.layer3.system1.System1;
import gus05.manager.gus.endorf.layer3.tools.Tools_debug;
import gus05.manager.gus.endorf.layer3.tools.Tools_file;

import java.io.File;
import java.util.Properties;

public class Loader_mapping extends Loader {

    
    
    public Loader_mapping()
    {super("mappings");}  
    
    
    protected void insideLoad()
    {
        try
        {
            Properties p = insideProp("mapping");
            if(p==null) return;
            putMapping(p);
            debug("insideLoad()","load "+p.size()+" mappings from inside");
        }
        catch(Exception e)
        {System1.handleError(this,"insideLoad()",e);}
    }
    
    
    
    
    
    protected void outsideLoad()
    {
        try
        {           
            File f = outsideFile(System1.PATH_MAPPINGFILE);
            if(f==null) return;
            
            Properties p = Tools_file.prop(f);
            putMapping(p);
            
            debug("outsideLoad()","load "+p.size()+" mappings from: "+f.getAbsolutePath());
        }
        catch(Exception e)
        {System1.handleError(this,"outsideLoad()",e);}
    }
    
    
    
    private void putMapping(Properties p)
    {
        System1.mapping.putAll(p);
        debug(p);
        increase(p.size());
    }
    
    
    private void debug(Properties p)
    {
        if(System1.booleanProperty_false(System1.PROPKEY_DEBUGMAPPING))
            Tools_debug.displayProp("from Loader_mapping",p);
    }
}
