package gus05.manager.gus.endorf.layer3.system1;

import java.io.File;
import gus05.manager.gus.endorf.layer3.tools.Tools_file;

import java.util.regex.Matcher;
import java.util.regex.Pattern;


public class FileManager {
    
    
	public final static int LOOKUP_LIMIT = 200;
	
	
    
    public File searchFile(String key)
    {
    	try{return searchFile(key,0);}
    	catch(Exception e)
    	{e("searchFile(String)",e);}
        return null;
    }
    
    
    
    
    
    public boolean checkFile(String key)
    {
        try
        {
            if(System1.hasFile(key)) return true;
            searchFile(key,0);
            return System1.hasFile(key);
        }
        catch(Exception e)
        {e("checkFile(String)",e);}
        return false;
    }
    
    
    
    
    

    
    
    
    
    private static final Pattern pattern_tag = Pattern.compile("<([^>]+)>");
    private static final Pattern pattern_move = Pattern.compile("\\[(-?[0-9]+)\\]");
    
    
    
    
    private File searchFile(String info, int c) throws Exception
    {
    	if(c>LOOKUP_LIMIT)
    		throw new Exception("Infinite loop detected: stopping at value "+info);
    	
    	if(System1.hasFile(info))
    		return System1.getFile(info);

    	if(info.startsWith("path."))
    	{
    		if(!System1.hasProperty(info))
    			return null;

    		String newInfo = System1.getProperty(info);
    		File f = searchFile(newInfo,++c);
    		if(f!=null) System1.putFile(info,f);
    		return f;
    	}
    	
    	if(info.startsWith("["))
    	{
    		Matcher m = pattern_move.matcher(info);
            if(!m.find()) throw new Exception("Wrong syntax for fileID rule: "+info);
            if(m.start()>0) throw new Exception("Wrong syntax for fileID rule: "+info);
            
            int move = Integer.parseInt(m.group(1));
            String tail = info.substring(m.end());
            
            File f_tail = searchFile(tail,++c);
            return moveFile(f_tail,move);
    	}

    	if(info.startsWith("<"))
    	{
    		Matcher m = pattern_tag.matcher(info);
            if(!m.find()) throw new Exception("Wrong syntax for fileID rule: "+info);
            if(m.start()>0) throw new Exception("Wrong syntax for fileID rule: "+info);
            
            String tag = m.group(1);
            String tail = info.substring(m.end());
            if(tail.startsWith(File.separator)) tail = tail.substring(1);
            
            File f_tag = searchFile(tag,++c);
            return Tools_file.fileOS(f_tag,tail);
    	}
    	
        return Tools_file.fileOS(info);
    }
    
    
    
    
    
    
    
    

    
    
    private File moveFile(File file, int move)
    {
    	int deep = deep(file);
    	int delta = move<0?move*-1:deep-move;
    	
    	for(int i=0;i<delta;i++)
    		file = file.getParentFile();
    	return file;
    }
    
    
    
    
    private int deep(File file)
    {
    	int d = 0;
    	while(file.getParentFile()!=null)
    	{file = file.getParentFile();d++;}
    	return d;
    }
    
    
    
    

    
    public void initFile(File file)
    {
        try
        {
            if(!System1.initOutside || file.exists()) return;
            file.getParentFile().mkdirs();
            file.createNewFile();
            d("initFile(File)","create file: "+file.getAbsolutePath());
        }
        catch(Exception e)
        {e("initFile(File)",e);}
    }
    
    
    
    
    
    public void initDir(File file)
    {
        try
        {
            if(!System1.initOutside || file.exists()) return;
            file.mkdirs();
            d("initFile(File)","create dir: "+file.getAbsolutePath());
        }
        catch(Exception e)
        {e("initDir(File)",e);}
    }
    
    
    
    
    
    private void d(String id, String message)
    {System1.printDebug(this,id,message);}
    
    private void e(String id, Exception e)
    {System1.handleError(this,id,e);}
    
} 
