package gus05.manager.gus.endorf.layer3.tools;

import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLClassLoader;

public class Tools_jar {

    
    private static File extDir;
    private static String s = File.pathSeparator;
    private static String classPath = s+System.getProperty("java.class.path")+s;
    
    
    
    public static Class loadClass(File jarFile, String classpath) throws MalformedURLException, ClassNotFoundException
    {
        URL url = jarFile.toURI().toURL();
        URLClassLoader loader = new URLClassLoader(new URL[]{url});
        return loader.loadClass(classpath);
    }
    
    
    
    private static File extDir()
    {
        if(extDir==null)
        {
            String[] paths = System.getProperty("java.ext.dirs").split(s);
            extDir = new File(paths[0]);
        }
        return extDir;
    }
    
    
    
    
    public static boolean belongToClassPath(File jarFile)
    {
        String value = s+jarFile.getAbsolutePath()+s;
        return classPath.contains(value);
    }
    
    
    
    
    public static void checkExtJar(File jarFile, String entityName) throws Exception
    {
        boolean known = belongToClassPath(jarFile);
        if(known)return;
        
        File jarFile2 = new File(extDir(),jarFile.getName());
        if(jarFile.exists())return;
        
        Tools_file.COPY(jarFile,jarFile2);
        throw new Exception("external jar file "+jarFile.getName()+" has just been detected for entity "+entityName);
    }
    
    
    
    
    
    public static void copyToExt(File jarFile) throws Exception
    {
        File jarFile2 = new File(extDir(),jarFile.getName());
        Tools_file.COPY(jarFile,jarFile2);
    }
}
